
/* Chrysalide - Outil d'analyse de fichiers binaires
 * ##FILE## - traduction d'instructions ARMv7
 *
 * Copyright (C) 2015 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


@title ADD (SP plus register, Thumb)

@desc This instruction adds an optionally-shifted register value to the SP value, and writes the result to the destination register.

@encoding (t1) {

	@half 0 1 0 0 0 1 0 0 DM(1) 1 1 0 1 Rdm(3)

	@syntax <reg_DM_1> <SP> <reg_DM_2>

	@conv {

		reg_DM_1 = Register(DM:Rdm)
		reg_DM_2 = Register(DM:Rdm)
		SP = Register(13)

	}

}

@encoding (t2) {

	@half 0 1 0 0 0 1 0 0 1 Rm(4) 1 0 1

	@syntax <SP> <reg_M>

	@conv {

		reg_M = Register(Rm)
		SP = Register(13)

	}

}

@encoding (T3) {

	@word 1 1 1 0 1 0 1 1 0 0 0 S(1) 1 1 0 1 0 imm3(3) Rd(4) imm2(2) type(2) Rm(4)

	@syntax <reg_D> <SP> <reg_M> <?shift>

	@conv {

		reg_D = Register(Rd)
		reg_M = Register(Rm)
		setflags = (S == '1')
		shift = DecodeImmShift(type, imm3:imm2)
		SP = Register(13)

	}

	@rules {

		if (setflags); chk_call ExtendKeyword("s")
		chk_call ExtendKeyword(".w")

	}

}

