
/* Chrysalide - Outil d'analyse de fichiers binaires
 * overjump.h - prototypes pour le greffon assurant un désassemblage pour les architectures Intel
 *
 * Copyright (C) 2009-2017 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _PLUGINS_OVERJUMP_H
#define _PLUGINS_OVERJUMP_H


#include <glib-object.h>
#include <gmodule.h>
#include <stdbool.h>


#include "../plugin-def.h"



/* Initialise le greffon pour le désassemblage Intel. */
bool init_plugin(GObject *);



/* Fournit une indication sur le type d'opération(s) menée(s). */
G_MODULE_EXPORT PluginAction get_plugin_action(void);

/* S'occupe du désassemblage (pur) de code binaire. */
G_MODULE_EXPORT GRenderingLine *disassemble_binary_parts(openida_binary *);



#endif  /* _PLUGINS_OVERJUMP_H */
